package com.rxida.xilinedu.sys.entity;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

public class Menu extends BaseEntity{
    private String id;
    private String parentId;
    private String name;
    private String icon;
    private String href;
    private Integer sort;

    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    private String component;

    public String getComponent() {
        return "MyTable";
    }

    public void setComponent(String component) {
        this.component = component;
    }

    private List<Menu> items = new ArrayList<>();

    public List<Menu> getItems() {
        return items;
    }

    public void setItems(List<Menu> items) {
        this.items = items;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getIcon() {
        return icon;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }

    public String getHref() {
        return "MyTable";
    }

    public void setHref(String href) {
        this.href = href;
    }

    public static Menu getChild(Menu menu, List<Menu> menuList) {
        for (Menu item : menuList) {
            if (menu.getId().equals(item.getParentId())) {
                menu.items.add(item);
            }
        }
        for (Menu item : menu.items) {
            getChild(item, menuList);
        }
        menu.items.sort(Comparator.comparing(Menu::getSort));
        return menu;
    }

    public Menu getChild(List<Menu> menuList) {
        return getChild(this, menuList);
    }
}
